3 # Copyright (c) 2006 - 2007 Kungliga Tekniska Högskolan
4 # (Royal Institute of Technology, Stockholm, Sweden).
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
11 # 1. Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
14 # 2. Redistributions in binary form must reproduce the above copyright
15 # notice, this list of conditions and the following disclaimer in the
16 # documentation and/or other materials provided with the distribution.
18 # 3. Neither the name of the Institute nor the names of its contributors
19 # may be used to endorse or promote products derived from this software
20 # without specific prior written permission.
22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
25 # ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
34 top_builddir
="@top_builddir@"
35 env_setup
="@env_setup@"
39 testfailed
="echo test failed; cat messages.log; exit 1"
43 # If there is no useful db support compiled in, disable test
50 kadmin
="${kadmin} -l -r $R"
51 kdc
="${kdc} --addresses=localhost -P $port"
53 server
=host
/datan.
test.h5l.se
54 cache
="FILE:${objdir}/cache.krb5"
55 ocache
="FILE:${objdir}/ocache.krb5"
56 keytabfile
=${objdir}/server.keytab
57 keytab
="FILE:${keytabfile}"
59 kinit
="${kinit} -c $cache ${afs_no_afslog}"
60 klist
="${klist} -c $cache"
61 kdigest
="${kdigest} --ccache=$cache"
64 userpassword
=digestpassword
68 KRB5_CONFIG
="${objdir}/krb5.conf"
78 echo Creating database
81 --realm-max-ticket-life=1day \
82 --realm-max-renewable-life=1month \
85 ${kadmin} add -p $userpassword --use-defaults ${username}@${R} ||
exit 1
86 ${kadmin} add -p $password --use-defaults ${server}@${R} ||
exit 1
87 ${kadmin} add -p kaka --use-defaults digest/${R}@${R} ||
exit 1
88 ${kadmin} modify --attributes=+allow-digest ${server}@${R} ||
exit 1
89 ${kadmin} ext -k ${keytab} ${server}@${R} ||
exit 1
91 echo "Doing database check"
92 ${kadmin} check
${R} ||
exit 1
94 echo $password > ${objdir}/foopassword
96 echo "Starting kdc" ; > messages.log
97 env
${HEIM_MALLOC_DEBUG} ${kdc} --detach --testing ||
98 { echo "kdc failed to start"; cat messages.log
; exit 1; }
101 trap "kill -9 ${kdcpid}; echo signal killing kdc; cat messages.log; exit 1;" EXIT
105 echo "Getting digest server tickets"
106 ${kinit} --password-file=${objdir}/foopassword ${server}@
$R || exitcode
=1
107 ${kdigest} digest-server-init \
108 --kerberos-realm=${R} \
109 --type=CHAP
> /dev
/null || exitcode
=1
113 NTLM_ACCEPTOR_CCACHE
="$cache"
114 export NTLM_ACCEPTOR_CCACHE
116 echo "Trying server-init"
117 ${kdigest} ntlm-server-init \
118 --kerberos-realm=${R} \
119 > sdigest-init || exitcode
=1
122 ${test_ntlm} ||
{ echo "test_ntlm failed"; exit 1; }
124 NTLM_USER_FILE
="${srcdir}/ntlm-user-file.txt"
125 export NTLM_USER_FILE
127 echo "test_context --mech-type=ntlm"
128 ${test_context} --mech-type=ntlm \
129 --client-name=foo@TEST \
130 --name-type=hostbased-service datan@TEST || \
131 { echo "test_context 1 failed"; exit 1; }
133 ${test_context} --mech-type=ntlm \
134 --client-name=foo@TEST \
135 --name-type=hostbased-service datan@
host.TEST || \
136 { echo "test_context 2 failed"; exit 1; }
138 ${test_context} --mech-type=ntlm \
139 --client-name=foo@TEST \
140 --name-type=hostbased-service datan@
host.
test.domain2 || \
141 { echo "test_context 3 failed"; exit 1; }
143 echo "Trying SL in NTLM"
150 "--getverifymic --wrapunwrap" \
153 echo "Trying NTLM type: ${type}"
154 ${test_context} --mech-type=ntlm
${type} \
155 --client-name=foo@TEST \
156 --name-type=hostbased-service datan@TEST || \
157 { echo "test_context 1 failed"; exit 1; }
164 ${kdigest} digest-server-init \
165 --kerberos-realm=${R} \
167 > sdigest-reply || exitcode
=1
169 snonce
=`grep server-nonce= sdigest-reply | cut -f2- -d=`
170 identifier
=`grep identifier= sdigest-reply | cut -f2- -d=`
171 opaque
=`grep opaque= sdigest-reply | cut -f2- -d=`
173 ${kdigest} digest-client-request \
175 --username="$username" \
176 --password="$userpassword" \
178 --server-identifier="$identifier" \
179 --server-nonce="$snonce" \
180 > cdigest-reply || exitcode
=1
182 cresponseData
=`grep responseData= cdigest-reply | cut -f2- -d=`
184 #echo user: $username
185 #echo server-nonce: $snonce
186 #echo opaqeue: $opaque
187 #echo identifier: $identifier
189 ${kdigest} digest-server-request \
190 --kerberos-realm=${R} \
192 --username="$username" \
194 --client-response="$cresponseData" \
195 --server-identifier="$identifier" \
196 --server-nonce="$snonce" \
197 > s2digest-reply || exitcode
=1
199 status
=`grep status= s2digest-reply | cut -f2- -d=`
201 if test "X$status" = "Xok" ; then
202 echo "CHAP response ok"
204 echo "CHAP response failed"
208 cresponseData
=`echo $cresponseData | sed 's/..../DEADBEEF/'`
210 ${kdigest} digest-server-request \
211 --kerberos-realm=${R} \
213 --username="$username" \
215 --client-response="$cresponseData" \
216 --server-identifier="$identifier" \
217 --server-nonce="$snonce" \
218 > s2digest-reply || exitcode
=1
220 status
=`grep status= s2digest-reply | cut -f2- -d=`
222 if test "X$status" = "Xfailed" ; then
223 echo "CHAP response fail as it should"
225 echo "CHAP response succeeded errorously"
229 echo "Trying MS-CHAP-V2"
231 ${kdigest} digest-server-init \
232 --kerberos-realm=${R} \
234 > sdigest-reply || exitcode
=1
236 snonce
=`grep server-nonce= sdigest-reply | cut -f2- -d=`
237 opaque
=`grep opaque= sdigest-reply | cut -f2- -d=`
238 cnonce
="21402324255E262A28295F2B3A337C7E"
240 echo "MS-CHAP-V2 client request"
241 ${kdigest} digest-client-request \
243 --username="$username" \
244 --password="$userpassword" \
246 --client-nonce="$cnonce" \
247 --server-nonce="$snonce" \
248 > cdigest-reply || exitcode
=1
250 cresponseData
=`grep responseData= cdigest-reply | cut -f2- -d=`
251 cRsp
=`grep AuthenticatorResponse= cdigest-reply | cut -f2- -d=`
252 ckey
=`grep session-key= cdigest-reply | cut -f2- -d=`
254 ${kdigest} digest-server-request \
255 --kerberos-realm=${R} \
257 --username="$username" \
259 --client-response="$cresponseData" \
260 --client-nonce="$cnonce" \
261 --server-nonce="$snonce" \
262 > s2digest-reply || exitcode
=1
264 status
=`grep status= s2digest-reply | cut -f2- -d=`
265 sRsp
=`grep rsp= s2digest-reply | cut -f2- -d=`
266 skey
=`grep session-key= s2digest-reply | cut -f2- -d=`
268 if test "X$sRsp" != "X$cRsp" ; then
269 echo "rsp wrong $sRsp != $cRsp"
273 if test "X$skey" != "X$ckey" ; then
278 if test "X$status" = "Xok" ; then
279 echo "MS-CHAP-V2 response ok"
281 echo "MS-CHAP-V2 response failed"
287 echo "killing kdc (${kdcpid})"
288 sh
${leaks_kill} kdc
$kdcpid ||
exit 1